<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: index.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: index.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>import * as THREE from 'three'

/**
 * Initiate a sceen for threeJS
 */
class Scene {
  constructor(fov = 75, aspect = 1, near = 0.1, far = 1000) {
    this.size = this._scene = new THREE.Scene()
    this._camera = new THREE.PerspectiveCamera(fov, aspect, near, far)
    this._camera.position.z = 5

    this._renderer = new THREE.WebGLRenderer()
    this._renderer.setSize(window.innerWidth, window.innerHeight)
    this._initOnResize(this._camera, this._renderer)
    document.body.appendChild(this._renderer.domElement)

    // Add geometry
    const geometry = new THREE.BoxGeometry()
    const material = new THREE.MeshBasicMaterial({ color: 0x00ff00 })
    const cube = new THREE.Mesh(geometry, material)
    this._scene.add(cube)
    this.animateCube(cube)
  }

  animateCube(cube) {
    requestAnimationFrame(this.animateCube.bind(this, cube))
    cube.rotation.x += 0.01
    cube.rotation.y += 0.01
    this._renderer.render(this._scene, this._camera)
  }

  /**
   * Get the size and the ratio aspect of the window
   * @retuns {object} - {width,height,ratio}
   */
  getSize() {
    return {
      width: window.innerWidth,
      height: window.innerHeight,
      ratio: window.innerWidth / window.innerHeight,
    }
  }

  /**
   * Update when window resize.
   * @private
   */
  _initOnResize(camera, renderer) {
    window.addEventListener(
      'resize',
      () => {
        this.size = this.getSize()
        camera.aspect = this.size.ratio
        camera.updateProjectionMatrix()
        renderer.setSize(this.size.width, this.size.height)
      },
      false
    )
  }
}

new Scene()
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="Scene.html">Scene</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.6</a> on Sat Mar 06 2021 09:20:46 GMT+0100 (Central European Standard Time)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
